import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogTripFeedback } from '../dialogs/dialog.tripfeedback';

export class FormTripFeedback extends FormSOP {
  public listTripFeedback = new ListTripFeedback();

  public constructor() {
    super('FormFeedbackTrips');
  }
}

export class ListTripFeedback extends ListSOP<DialogTripFeedback, ListTripFeedbackColumn> {
  public static readonly title = 'Trip Feedback';

  public constructor() {
    super('FormFeedbackTrips.PanelFeedbackTrips', new DialogTripFeedback());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { 'Lane Leg': '', Unit: '' };
  }
}

export interface ListTripFeedbackColumn {
  'All constraints'?: string;
  'Lane Leg'?: string;
  Unit?: string;
  Arrival?: string;
  Product?: string;
  'Stocking Point'?: string;
  Quantity?: string;
  UoM?: string;
  Description?: string;
}

const listTripFeedbackContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuFeedbackTrips', Name: 'MenuCreate', Label: 'Create' },
  Edit: { ContextMenu: 'listContextMenuFeedbackTrips', Name: 'MenuEdit', Label: 'Edit' },
};

export { listTripFeedbackContextMenuItem as ListTripFeedbackContextMenuItem };
